(** val unit_rect : 'a1 -> unit -> 'a1 **)

let unit_rect f u =
  f

(** val unit_rec : 'a1 -> unit -> 'a1 **)

let unit_rec f u =
  f

(** val bool_rect : 'a1 -> 'a1 -> bool -> 'a1 **)

let bool_rect f f0 = function
  | true -> f
  | false -> f0

(** val bool_rec : 'a1 -> 'a1 -> bool -> 'a1 **)

let bool_rec f f0 = function
  | true -> f
  | false -> f0

(** val nat_rect : 'a1 -> (int -> 'a1 -> 'a1) -> int -> 'a1 **)

let rec nat_rect = (let rec recursor f f0 n =
    assert(n >= 0);
    if n = 0
    then f
    else let n0 = pred n in f0 n0 (recursor f f0 n0) in recursor)

(** val nat_rec : 'a1 -> (int -> 'a1 -> 'a1) -> int -> 'a1 **)

let nat_rec = nat_rect

type coq_Empty_set = unit (* empty inductive *)

(** val coq_Empty_set_rect : coq_Empty_set -> 'a1 **)

let coq_Empty_set_rect e =
  assert false (* absurd case *)

(** val coq_Empty_set_rec : coq_Empty_set -> 'a1 **)

let coq_Empty_set_rec e =
  assert false (* absurd case *)

type 'a identity =
  | Coq_refl_identity

(** val identity_rect : 'a1 -> 'a2 -> 'a1 -> 'a1 identity -> 'a2 **)

let identity_rect a f y i =
  f

(** val identity_rec : 'a1 -> 'a2 -> 'a1 -> 'a1 identity -> 'a2 **)

let identity_rec a f y i =
  f

(** val option_rect : ('a1 -> 'a2) -> 'a2 -> 'a1 option -> 'a2 **)

let option_rect f f0 = function
  | Some x -> f x
  | None -> f0

(** val option_rec : ('a1 -> 'a2) -> 'a2 -> 'a1 option -> 'a2 **)

let option_rec f f0 = function
  | Some x -> f x
  | None -> f0

type ('a, 'b) sum =
  | Coq_inl of 'a
  | Coq_inr of 'b

(** val sum_rect : ('a1 -> 'a3) -> ('a2 -> 'a3) -> ('a1, 'a2) sum -> 'a3 **)

let sum_rect f f0 = function
  | Coq_inl x -> f x
  | Coq_inr x -> f0 x

(** val sum_rec : ('a1 -> 'a3) -> ('a2 -> 'a3) -> ('a1, 'a2) sum -> 'a3 **)

let sum_rec f f0 = function
  | Coq_inl x -> f x
  | Coq_inr x -> f0 x

(** val prod_rect : ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) pair -> 'a3 **)

let prod_rect f = function
  |  (x, x0) -> f x x0

(** val prod_rec : ('a1 -> 'a2 -> 'a3) -> ('a1, 'a2) pair -> 'a3 **)

let prod_rec f = function
  |  (x, x0) -> f x x0

(** val fst : ('a1, 'a2) pair -> 'a1 **)

let fst = function
  |  (x, y) -> x

(** val snd : ('a1, 'a2) pair -> 'a2 **)

let snd = function
  |  (x, y) -> y

type comparison =
  | Eq
  | Lt
  | Gt

(** val comparison_rect : 'a1 -> 'a1 -> 'a1 -> comparison -> 'a1 **)

let comparison_rect f f0 f1 = function
  | Eq -> f
  | Lt -> f0
  | Gt -> f1

(** val comparison_rec : 'a1 -> 'a1 -> 'a1 -> comparison -> 'a1 **)

let comparison_rec f f0 f1 = function
  | Eq -> f
  | Lt -> f0
  | Gt -> f1

(** val coq_CompOpp : comparison -> comparison **)

let coq_CompOpp = function
  | Eq -> Eq
  | Lt -> Gt
  | Gt -> Lt

