open Compare_dec
open Datatypes
open Max
open Peano
open Specif
open Sumbool
open Computable_total_ordering
open Runtime

type __ = Obj.t

module Make : 
 functor (Domain:Computable_total_ordering.ORDERED_SET) ->
 sig 
  module Domain : 
   sig 
    type t = Domain.t
    
    val compare : t -> t -> t comparison
   end
  
  type 'x t 
  
  val empty : unit -> 'a1 t
  
  val find : Domain.t -> 'a1 t -> 'a1 option
  
  val add : Domain.t -> 'a1 -> 'a1 t -> 'a1 t
  
  val func_add :
    Domain.t -> 'a1 -> (Domain.t -> 'a1 option) -> Domain.t -> 'a1 option
  
  val remove : Domain.t -> 'a1 t -> 'a1 t
  
  val func_remove :
    Domain.t -> (Domain.t -> 'a1 option) -> Domain.t -> 'a1 option
  
  val mapi1_opt : (Domain.t -> 'a1 -> 'a2 option) -> 'a1 t -> 'a2 t
  
  val func_mapi1_opt :
    (Domain.t -> 'a1 -> 'a2 option) -> (Domain.t -> 'a1 option) -> Domain.t
    -> 'a2 option
  
  val func_mapi2_opt :
    (Domain.t -> 'a1 -> 'a3 option) -> (Domain.t -> 'a2 -> 'a3 option) ->
    (Domain.t -> 'a1 -> 'a2 -> 'a3 option) -> (Domain.t -> 'a1 option) ->
    (Domain.t -> 'a2 option) -> Domain.t -> 'a3 option
  
  val mapi2_opt :
    (Domain.t -> 'a1 -> 'a3 option) -> (Domain.t -> 'a2 -> 'a3 option) ->
    (Domain.t -> 'a1 -> 'a2 -> 'a3 option) -> 'a1 t -> 'a2 t -> 'a3 t
 end

